diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index 5f7ccf19514..5295602984c 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -596,7 +596,6 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
     while (1)
     {
         LONG value;
-        int inst_id = -1;
 
 	plfd.fd = This->joyfd;
 	plfd.events = POLLIN;
@@ -609,19 +608,11 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
         TRACE("js_event: type 0x%x, number %d, value %d\n",
               jse.type,jse.number,jse.value);
         if (jse.type & JS_EVENT_BUTTON)
-        {
-            if (jse.number >= This->joydev->button_count) return;
-
-            inst_id = DIDFT_MAKEINSTANCE(jse.number) | DIDFT_PSHBUTTON;
-            This->generic.js.rgbButtons[jse.number] = value = jse.value ? 0x80 : 0x00;
-        }
+            win32_funcs->joystick_queue_event(&This->generic, DIDFT_PSHBUTTON, jse.number, jse.value ? 0x80 : 0x00);
         else if (jse.type & JS_EVENT_AXIS)
         {
             int number = win32_funcs->joystick_get_axis(&This->generic, jse.number);
-
             if (number < 0) return;
-            inst_id = number < 8 ?  DIDFT_MAKEINSTANCE(number) | DIDFT_ABSAXIS :
-                                    DIDFT_MAKEINSTANCE(number - 8) | DIDFT_POV;
             value = joystick_map_axis(&This->generic.props[This->joydev->axes_map[jse.number]], jse.value);
 
             TRACE("changing axis %d => %d\n", jse.number, number);
@@ -650,8 +641,9 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
                 default:
                     WARN("axis %d not supported\n", number);
             }
+            if (number < 8) win32_funcs->joystick_queue_event(&This->generic, DIDFT_ABSAXIS, number, value);
+            else win32_funcs->joystick_queue_event(&This->generic, DIDFT_POV, number - 8, value);
         }
-        if (inst_id >= 0) win32_funcs->joystick_queue_event(&This->generic, inst_id, value);
     }
 }
 
diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index 4a21d67752f..a7ebb95fe58 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -764,7 +764,6 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
     while (1)
     {
         LONG value = 0;
-        int inst_id = -1;
 
 	plfd.fd = This->joyfd;
 	plfd.events = POLLIN;
@@ -781,14 +780,8 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
 	case EV_KEY:	/* button */
         {
             int btn = This->joydev->buttons[ie.code];
-
             TRACE("(%p) %d -> %d\n", This, ie.code, btn);
-            if (btn & 0x80)
-            {
-                btn &= 0x7F;
-                inst_id = DIDFT_MAKEINSTANCE(btn) | DIDFT_PSHBUTTON;
-                This->generic.js.rgbButtons[btn] = value = ie.value ? 0x80 : 0x00;
-            }
+            if (btn & 0x80) win32_funcs->joystick_queue_event(&This->generic, DIDFT_PSHBUTTON, btn & 0x7f, ie.value ? 0x80 : 0x00);
             break;
         }
 	case EV_ABS:
@@ -799,9 +792,6 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
             if (axis < 0) break;
             axis = win32_funcs->joystick_get_axis(&This->generic, axis);
             if (axis < 0) break;
-
-            inst_id = axis < 8 ?  DIDFT_MAKEINSTANCE(axis) | DIDFT_ABSAXIS :
-                                  DIDFT_MAKEINSTANCE(axis - 8) | DIDFT_POV;
             value = joystick_map_axis(&This->generic.props[This->joydev->dev_axes_to_di[ie.code]], ie.value);
 
 	    switch (axis) {
@@ -828,7 +818,9 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
 	    default:
 		FIXME("unhandled joystick axis event (code %d, value %d)\n",ie.code,ie.value);
 	    }
-	    break;
+            if (axis < 8) win32_funcs->joystick_queue_event(&This->generic, DIDFT_ABSAXIS, axis, value);
+            else win32_funcs->joystick_queue_event(&This->generic, DIDFT_POV, axis - 8, value);
+            break;
         }
 #ifdef HAVE_STRUCT_FF_EFFECT_DIRECTION
 	case EV_FF_STATUS:
@@ -849,7 +841,6 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
 	    TRACE("skipping event\n");
 	    break;
 	}
-        if (inst_id >= 0) win32_funcs->joystick_queue_event(&This->generic, inst_id, value);
     }
 }
 
diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index d41dda7ddd0..ab999875170 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -826,7 +826,6 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
         int button_idx = 0;
         int pov_idx = 0;
         int slider_idx = 0;
-        int inst_id;
         CFIndex idx, cnt = CFArrayGetCount( device->elements );
 
         for ( idx = 0; idx < cnt; idx++ )
@@ -850,15 +849,7 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
                         if (valueRef == NULL)
                             return;
                         val = IOHIDValueGetIntegerValue(valueRef);
-                        newVal = val ? 0x80 : 0x0;
-                        oldVal = device->generic.js.rgbButtons[button_idx];
-                        device->generic.js.rgbButtons[button_idx] = newVal;
-                        TRACE("valueRef %s val %d oldVal %d newVal %d\n", debugstr_cf(valueRef), val, oldVal, newVal);
-                        if (oldVal != newVal)
-                        {
-                            inst_id = DIDFT_MAKEINSTANCE(button_idx) | DIDFT_PSHBUTTON;
-                            win32_funcs->joystick_queue_event(&device->generic, inst_id, newVal);
-                        }
+                        win32_funcs->joystick_queue_event(&device->generic, DIDFT_PSHBUTTON, button_idx, val ? 0x80 : 0x0);
                         button_idx ++;
                     }
                     break;
@@ -884,10 +875,7 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
                             device->generic.js.rgdwPOV[pov_idx] = newVal;
                             TRACE("valueRef %s val %d oldVal %d newVal %d\n", debugstr_cf(valueRef), val, oldVal, newVal);
                             if (oldVal != newVal)
-                            {
-                                inst_id = DIDFT_MAKEINSTANCE(pov_idx) | DIDFT_POV;
-                                win32_funcs->joystick_queue_event(&device->generic, inst_id, newVal);
-                            }
+                                win32_funcs->joystick_queue_event(&device->generic, DIDFT_POV, pov_idx, newVal);
                             pov_idx ++;
                             break;
                         }
@@ -955,12 +943,8 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
                                 break;
                             }
                             TRACE("valueRef %s val %d oldVal %d newVal %d\n", debugstr_cf(valueRef), val, oldVal, newVal);
-                            if ((wine_obj != -1) &&
-                                 (oldVal != newVal))
-                            {
-                                inst_id = DIDFT_MAKEINSTANCE(wine_obj) | DIDFT_ABSAXIS;
-                                win32_funcs->joystick_queue_event(&device->generic, inst_id, newVal);
-                            }
+                            if ((wine_obj != -1) && (oldVal != newVal))
+                                win32_funcs->joystick_queue_event(&device->generic, DIDFT_ABSAXIS, wine_obj, newVal);
 
                             break;
                         }
diff --git a/dlls/dinput/joystick_private.h b/dlls/dinput/joystick_private.h
index b088f6c851a..4dee1ae1948 100644
--- a/dlls/dinput/joystick_private.h
+++ b/dlls/dinput/joystick_private.h
@@ -83,7 +83,7 @@ DWORD joystick_map_pov(const POINTL *p) DECLSPEC_HIDDEN;
 extern BOOL device_disabled_registry(const WCHAR* name) DECLSPEC_HIDDEN;
 
 extern int CDECL dinput_unix_joystick_get_axis(JoystickGenericImpl *This, int index) DECLSPEC_HIDDEN;
-extern void CDECL dinput_unix_joystick_queue_event(JoystickGenericImpl *This, int inst_id, DWORD data) DECLSPEC_HIDDEN;
+extern void CDECL dinput_unix_joystick_queue_event(JoystickGenericImpl *This, WORD type, int index, DWORD data) DECLSPEC_HIDDEN;
 
 HRESULT WINAPI JoystickWGenericImpl_GetObjectInfo(LPDIRECTINPUTDEVICE8W iface,
         LPDIDEVICEOBJECTINSTANCEW pdidoi, DWORD dwObj, DWORD dwHow) DECLSPEC_HIDDEN;
-- 
2.28.0

>From c0d034ece76e2478d016c7e498e5f5cde82c56fd Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Tue, 6 Oct 2020 11:44:18 +0200
Subject: [PATCH 33/39] dinput: Update joystick axis and pov state on
 queue_event.

---
 dlls/dinput/joystick.c            | 19 ++++++++++++
 dlls/dinput/joystick_linux.c      | 41 ++++++--------------------
 dlls/dinput/joystick_linuxinput.c | 38 ++++++------------------
 dlls/dinput/joystick_osx.c        | 48 +++++++------------------------
 4 files changed, 47 insertions(+), 99 deletions(-)

diff --git a/dlls/dinput/joystick.c b/dlls/dinput/joystick.c
index 0a9c0b3f158..ac2e53489bb 100644
--- a/dlls/dinput/joystick.c
+++ b/dlls/dinput/joystick.c
@@ -1310,6 +1310,25 @@ void CDECL dinput_unix_joystick_queue_event(JoystickGenericImpl *This, WORD type
         if (index < 0 || index >= This->devcaps.dwButtons) return;
         This->js.rgbButtons[index] = data;
         break;
+    case DIDFT_ABSAXIS:
+        if (index < 0 || index >= This->devcaps.dwAxes) return;
+        data = joystick_map_axis(&This->props[index], data);
+        switch (index)
+        {
+        case 0: This->js.lX = data; break;
+        case 1: This->js.lY = data; break;
+        case 2: This->js.lZ = data; break;
+        case 3: This->js.lRx = data; break;
+        case 4: This->js.lRy = data; break;
+        case 5: This->js.lRz = data; break;
+        case 6: This->js.rglSlider[0] = data; break;
+        case 7: This->js.rglSlider[1] = data; break;
+        }
+        break;
+    case DIDFT_POV:
+        if (index < 0 || index >= This->devcaps.dwPOVs) return;
+        This->js.rgdwPOV[index] = data;
+        break;
     }
 
     queue_event(&This->base.IDirectInputDevice8W_iface, didft, data, GetCurrentTime(), This->base.dinput->evsequence++);
diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index 5295602984c..8ca6deb90b6 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -595,8 +595,6 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
     }
     while (1)
     {
-        LONG value;
-
 	plfd.fd = This->joyfd;
 	plfd.events = POLLIN;
 	if (poll(&plfd,1,0) != 1)
@@ -611,38 +609,17 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
             win32_funcs->joystick_queue_event(&This->generic, DIDFT_PSHBUTTON, jse.number, jse.value ? 0x80 : 0x00);
         else if (jse.type & JS_EVENT_AXIS)
         {
-            int number = win32_funcs->joystick_get_axis(&This->generic, jse.number);
-            if (number < 0) return;
-            value = joystick_map_axis(&This->generic.props[This->joydev->axes_map[jse.number]], jse.value);
-
-            TRACE("changing axis %d => %d\n", jse.number, number);
-            switch (number)
+            int axis = win32_funcs->joystick_get_axis(&This->generic, jse.number);
+            if (axis < 0) return;
+            TRACE("changing axis %d => %d\n", jse.number, axis);
+            if (axis >= 0 && axis < 8) win32_funcs->joystick_queue_event(&This->generic, DIDFT_ABSAXIS, axis, jse.value);
+            else if (axis >= 8 && axis < 12)
             {
-                case 0: This->generic.js.lX  = value; break;
-                case 1: This->generic.js.lY  = value; break;
-                case 2: This->generic.js.lZ  = value; break;
-                case 3: This->generic.js.lRx = value; break;
-                case 4: This->generic.js.lRy = value; break;
-                case 5: This->generic.js.lRz = value; break;
-                case 6: This->generic.js.rglSlider[0] = value; break;
-                case 7: This->generic.js.rglSlider[1] = value; break;
-                case 8: case 9: case 10: case 11:
-                {
-                    int idx = number - 8;
-
-                    if (jse.number % 2)
-                        This->povs[idx].y = jse.value;
-                    else
-                        This->povs[idx].x = jse.value;
-
-                    This->generic.js.rgdwPOV[idx] = value = joystick_map_pov(&This->povs[idx]);
-                    break;
-                }
-                default:
-                    WARN("axis %d not supported\n", number);
+                if (jse.number % 2) This->povs[axis - 8].y = jse.value;
+                else This->povs[axis - 8].x = jse.value;
+                win32_funcs->joystick_queue_event(&This->generic, DIDFT_POV, axis - 8, joystick_map_pov(&This->povs[axis - 8]));
             }
-            if (number < 8) win32_funcs->joystick_queue_event(&This->generic, DIDFT_ABSAXIS, number, value);
-            else win32_funcs->joystick_queue_event(&This->generic, DIDFT_POV, number - 8, value);
+            else WARN("axis %d not supported\n", axis);
         }
     }
 }
diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index a7ebb95fe58..b4559fffedc 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -763,8 +763,6 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
 
     while (1)
     {
-        LONG value = 0;
-
 	plfd.fd = This->joyfd;
 	plfd.events = POLLIN;
 
@@ -787,39 +785,19 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
 	case EV_ABS:
         {
             int axis = This->joydev->dev_axes_to_di[ie.code];
-
-            /* User axis remapping */
             if (axis < 0) break;
             axis = win32_funcs->joystick_get_axis(&This->generic, axis);
             if (axis < 0) break;
-            value = joystick_map_axis(&This->generic.props[This->joydev->dev_axes_to_di[ie.code]], ie.value);
-
-	    switch (axis) {
-            case 0: This->generic.js.lX  = value; break;
-            case 1: This->generic.js.lY  = value; break;
-            case 2: This->generic.js.lZ  = value; break;
-            case 3: This->generic.js.lRx = value; break;
-            case 4: This->generic.js.lRy = value; break;
-            case 5: This->generic.js.lRz = value; break;
-            case 6: This->generic.js.rglSlider[0] = value; break;
-            case 7: This->generic.js.rglSlider[1] = value; break;
-            case 8: case 9: case 10: case 11:
-            {
-                int idx = axis - 8;
-
-                if (ie.code % 2)
-                    This->povs[idx].y = ie.value;
-                else
-                    This->povs[idx].x = ie.value;
 
-                This->generic.js.rgdwPOV[idx] = value = joystick_map_pov(&This->povs[idx]);
-                break;
+            if (axis >= 0 && axis < 8) win32_funcs->joystick_queue_event(&This->generic, DIDFT_ABSAXIS, axis, ie.value);
+            else if (axis >= 8 && axis < 12)
+            {
+                if (ie.code % 2) This->povs[axis - 8].y = ie.value;
+                else This->povs[axis - 8].x = ie.value;
+                win32_funcs->joystick_queue_event(&This->generic, DIDFT_POV, axis - 8, joystick_map_pov(&This->povs[axis - 8]));
             }
-	    default:
-		FIXME("unhandled joystick axis event (code %d, value %d)\n",ie.code,ie.value);
-	    }
-            if (axis < 8) win32_funcs->joystick_queue_event(&This->generic, DIDFT_ABSAXIS, axis, value);
-            else win32_funcs->joystick_queue_event(&This->generic, DIDFT_POV, axis - 8, value);
+            else FIXME("unhandled joystick axis event (code %d, value %d)\n", ie.code, ie.value);
+
             break;
         }
 #ifdef HAVE_STRUCT_FF_EFFECT_DIRECTION
diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index ab999875170..5aebf2d570b 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -831,7 +831,7 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
         for ( idx = 0; idx < cnt; idx++ )
         {
             IOHIDValueRef valueRef;
-            int val, oldVal, newVal;
+            int val;
             IOHIDElementRef element = ( IOHIDElementRef ) CFArrayGetValueAtIndex( device->elements, idx );
             int type = IOHIDElementGetType( element );
 
@@ -867,15 +867,9 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
                             if (valueRef == NULL)
                                 return;
                             val = IOHIDValueGetIntegerValue(valueRef);
-                            oldVal = device->generic.js.rgdwPOV[pov_idx];
-                            if (val >= 8)
-                                newVal = -1;
-                            else
-                                newVal = val * 4500;
-                            device->generic.js.rgdwPOV[pov_idx] = newVal;
-                            TRACE("valueRef %s val %d oldVal %d newVal %d\n", debugstr_cf(valueRef), val, oldVal, newVal);
-                            if (oldVal != newVal)
-                                win32_funcs->joystick_queue_event(&device->generic, DIDFT_POV, pov_idx, newVal);
+                            if (val >= 8) val = -1;
+                            else val = val * 4500;
+                            win32_funcs->joystick_queue_event(&device->generic, DIDFT_POV, pov_idx, val);
                             pov_idx ++;
                             break;
                         }
@@ -887,64 +881,44 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
                         case kHIDUsage_GD_Rz:
                         case kHIDUsage_GD_Slider:
                         {
-                            int wine_obj = -1;
-
                             valueRef = NULL;
                             if (IOHIDDeviceGetValue(hid_device, element, &valueRef) != kIOReturnSuccess)
                                 return;
                             if (valueRef == NULL)
                                 return;
                             val = IOHIDValueGetIntegerValue(valueRef);
-                            newVal = joystick_map_axis(&device->generic.props[idx], val);
                             switch (usage)
                             {
                             case kHIDUsage_GD_X:
                                 TRACE("kIOHIDElementTypeInput_Misc / kHIDUsage_GD_X\n");
-                                wine_obj = 0;
-                                oldVal = device->generic.js.lX;
-                                device->generic.js.lX = newVal;
+                                win32_funcs->joystick_queue_event(&device->generic, DIDFT_ABSAXIS, 0, val);
                                 break;
                             case kHIDUsage_GD_Y:
                                 TRACE("kIOHIDElementTypeInput_Misc / kHIDUsage_GD_Y\n");
-                                wine_obj = 1;
-                                oldVal = device->generic.js.lY;
-                                device->generic.js.lY = newVal;
+                                win32_funcs->joystick_queue_event(&device->generic, DIDFT_ABSAXIS, 1, val);
                                 break;
                             case kHIDUsage_GD_Z:
                                 TRACE("kIOHIDElementTypeInput_Misc / kHIDUsage_GD_Z\n");
-                                wine_obj = 2;
-                                oldVal = device->generic.js.lZ;
-                                device->generic.js.lZ = newVal;
+                                win32_funcs->joystick_queue_event(&device->generic, DIDFT_ABSAXIS, 2, val);
                                 break;
                             case kHIDUsage_GD_Rx:
                                 TRACE("kIOHIDElementTypeInput_Misc / kHIDUsage_GD_Rx\n");
-                                wine_obj = 3;
-                                oldVal = device->generic.js.lRx;
-                                device->generic.js.lRx = newVal;
+                                win32_funcs->joystick_queue_event(&device->generic, DIDFT_ABSAXIS, 3, val);
                                 break;
                             case kHIDUsage_GD_Ry:
                                 TRACE("kIOHIDElementTypeInput_Misc / kHIDUsage_GD_Ry\n");
-                                wine_obj = 4;
-                                oldVal = device->generic.js.lRy;
-                                device->generic.js.lRy = newVal;
+                                win32_funcs->joystick_queue_event(&device->generic, DIDFT_ABSAXIS, 4, val);
                                 break;
                             case kHIDUsage_GD_Rz:
                                 TRACE("kIOHIDElementTypeInput_Misc / kHIDUsage_GD_Rz\n");
-                                wine_obj = 5;
-                                oldVal = device->generic.js.lRz;
-                                device->generic.js.lRz = newVal;
+                                win32_funcs->joystick_queue_event(&device->generic, DIDFT_ABSAXIS, 5, val);
                                 break;
                             case kHIDUsage_GD_Slider:
                                 TRACE("kIOHIDElementTypeInput_Misc / kHIDUsage_GD_Slider\n");
-                                wine_obj = 6 + slider_idx;
-                                oldVal = device->generic.js.rglSlider[slider_idx];
-                                device->generic.js.rglSlider[slider_idx] = newVal;
+                                win32_funcs->joystick_queue_event(&device->generic, DIDFT_ABSAXIS, 6 + slider_idx, val);
                                 slider_idx ++;
                                 break;
                             }
-                            TRACE("valueRef %s val %d oldVal %d newVal %d\n", debugstr_cf(valueRef), val, oldVal, newVal);
-                            if ((wine_obj != -1) && (oldVal != newVal))
-                                win32_funcs->joystick_queue_event(&device->generic, DIDFT_ABSAXIS, wine_obj, newVal);
 
                             break;
                         }
-- 
2.28.0

>From de7fa9ed38bb890a261df6e8319cafbbd43eec48 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Mon, 5 Oct 2020 20:58:16 +0200
Subject: [PATCH 34/39] dinput: Update joystick initial state using
 queue_event.

---
 dlls/dinput/device_private.h      |  1 -
 dlls/dinput/joystick.c            | 14 +++++++++++++-
 dlls/dinput/joystick_linuxinput.c | 27 +++++++++++----------------
 dlls/dinput/joystick_private.h    |  2 --
 4 files changed, 24 insertions(+), 20 deletions(-)

diff --git a/dlls/dinput/device_private.h b/dlls/dinput/device_private.h
index ef6bb05108f..0ba20abe68e 100644
--- a/dlls/dinput/device_private.h
+++ b/dlls/dinput/device_private.h
@@ -119,7 +119,6 @@ typedef struct
 } ObjProps;
 
 extern DWORD joystick_map_pov(const POINTL *p) DECLSPEC_HIDDEN;
-extern LONG joystick_map_axis(ObjProps *props, int val) DECLSPEC_HIDDEN;
 
 typedef struct
 {
diff --git a/dlls/dinput/joystick.c b/dlls/dinput/joystick.c
index ac2e53489bb..f226fa944e7 100644
--- a/dlls/dinput/joystick.c
+++ b/dlls/dinput/joystick.c
@@ -339,6 +339,8 @@ static BOOL is_xinput_device(const DIDEVCAPS *devcaps, WORD vid, WORD pid)
     return (devcaps->dwAxes == 6 && devcaps->dwButtons >= 14);
 }
 
+static LONG joystick_map_axis(ObjProps *props, int val);
+
 /******************************************************************************
   *     SetProperty : change input device properties
   */
@@ -982,7 +984,7 @@ HRESULT WINAPI JoystickWGenericImpl_SetActionMap(LPDIRECTINPUTDEVICE8W iface,
  * Notes:
  *   Dead zone is in % multiplied by a 100 (range 0..10000)
  */
-LONG joystick_map_axis(ObjProps *props, int val)
+static LONG joystick_map_axis(ObjProps *props, int val)
 {
     LONG ret;
     LONG dead_zone = MulDiv( props->lDeadZone, props->lDevMax - props->lDevMin, 10000 );
@@ -1225,6 +1227,16 @@ HRESULT dinput_create_unix_joystick(const struct dinput_device *device, IDirectI
     This->devcaps.dwFlags = DIDC_ATTACHED;
     This->devcaps.dwDevType = This->base.info.dwDevType;
 
+    This->js.lX = 0;
+    This->js.lY = 0;
+    This->js.lZ = 0;
+    This->js.lRx = 0;
+    This->js.lRy = 0;
+    This->js.lRz = 0;
+    This->js.rglSlider[0] = 0;
+    This->js.rglSlider[1] = 0;
+    for (i = 0; i < 4; i++) This->js.rgdwPOV[i] = -1;
+
     if (FAILED(hr = This->unix_funcs->init(This->unix_ptr, props, &prop_count, &has_ff))) goto done;
     memcpy(This->props, props, sizeof(This->props));
 
diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index b4559fffedc..f9fbffc0c0c 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -729,25 +729,20 @@ static HRESULT CDECL unix_joystick_ff_set_gain(struct unix_joystick *ptr, DWORD
  * values on the axes
  */
 #define CENTER_AXIS(a) \
-    (This->joydev->dev_axes_to_di[a] == -1 ? 0 : joystick_map_axis(&This->generic.props[This->joydev->dev_axes_to_di[a]], This->joydev->axes[a].value))
+    if ((axis = This->joydev->dev_axes_to_di[a]) >= 0) \
+        win32_funcs->joystick_queue_event(&This->generic, DIDFT_ABSAXIS, axis, This->joydev->axes[a].value)
 static void CDECL unix_joystick_reset(struct unix_joystick *ptr)
 {
     JoystickImpl *This = impl_from_unix_joystick(ptr);
-    int i;
-
-    /* center the axes */
-    This->generic.js.lX           = CENTER_AXIS(ABS_X);
-    This->generic.js.lY           = CENTER_AXIS(ABS_Y);
-    This->generic.js.lZ           = CENTER_AXIS(ABS_Z);
-    This->generic.js.lRx          = CENTER_AXIS(ABS_RX);
-    This->generic.js.lRy          = CENTER_AXIS(ABS_RY);
-    This->generic.js.lRz          = CENTER_AXIS(ABS_RZ);
-    This->generic.js.rglSlider[0] = CENTER_AXIS(ABS_THROTTLE);
-    This->generic.js.rglSlider[1] = CENTER_AXIS(ABS_RUDDER);
-
-    /* POV center is -1 */
-    for (i = 0; i < 4; i++)
-        This->generic.js.rgdwPOV[i] = -1;
+    int axis;
+    CENTER_AXIS(ABS_X);
+    CENTER_AXIS(ABS_Y);
+    CENTER_AXIS(ABS_Z);
+    CENTER_AXIS(ABS_RX);
+    CENTER_AXIS(ABS_RY);
+    CENTER_AXIS(ABS_RZ);
+    CENTER_AXIS(ABS_THROTTLE);
+    CENTER_AXIS(ABS_RUDDER);
 }
 #undef CENTER_AXIS
 
diff --git a/dlls/dinput/joystick_private.h b/dlls/dinput/joystick_private.h
index 4dee1ae1948..44d8731bdb1 100644
--- a/dlls/dinput/joystick_private.h
+++ b/dlls/dinput/joystick_private.h
@@ -76,8 +76,6 @@ typedef struct JoystickGenericImpl
 
 extern HRESULT dinput_create_unix_joystick(const struct dinput_device *device, IDirectInputImpl *dinput, REFGUID guid, REFIID iid, void **out) DECLSPEC_HIDDEN;
 
-LONG joystick_map_axis(ObjProps *props, int val) DECLSPEC_HIDDEN;
-
 DWORD joystick_map_pov(const POINTL *p) DECLSPEC_HIDDEN;
 
 extern BOOL device_disabled_registry(const WCHAR* name) DECLSPEC_HIDDEN;
-- 
2.28.0

>From 109ecdded8e1736893a07e5e3ac684f47eaef55d Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Tue, 6 Oct 2020 16:16:53 +0200
Subject: [PATCH 35/39] dinput: Use unix vtable and wrapper for joystick
 effects.

---
 dlls/dinput/device_private.h      |   6 -
 dlls/dinput/effect_linuxinput.c   | 247 ++++++++++--------------------
 dlls/dinput/joystick.c            | 200 ++++++++++++++++++++++--
 dlls/dinput/joystick_linuxinput.c |  27 +---
 dlls/dinput/joystick_osx.c        | 169 +++++++-------------
 dlls/dinput/joystick_private.h    |  18 ++-
 6 files changed, 348 insertions(+), 319 deletions(-)

diff --git a/dlls/dinput/device_private.h b/dlls/dinput/device_private.h
index 0ba20abe68e..d6ce489c3e1 100644
--- a/dlls/dinput/device_private.h
+++ b/dlls/dinput/device_private.h
@@ -120,12 +120,6 @@ typedef struct
 
 extern DWORD joystick_map_pov(const POINTL *p) DECLSPEC_HIDDEN;
 
-typedef struct
-{
-    struct list entry;
-    LPDIRECTINPUTEFFECT ref;
-} effect_list_item;
-
 extern const GUID DInput_PIDVID_Product_GUID DECLSPEC_HIDDEN;
 
 /* Various debug tools */
